
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Constants ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Orig_PM_Target_seg = RMPARTCS ;PMPARTCS
Orig_PM_Target_ofs = GoReal ;PM_Entry_Point
Orig_RM_Target_seg = APISEG
Orig_RM_Target_ofs = RM_Return_Point




rminit

__dataseg__({
;;;;;;;;;;;;;;;;;;;;;;;;;; Initialization Data ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.align 4
Orig_GDT:
	DefDescriptor(0,0x00000,0x00,0x0)	; Invalid NULL descriptor
	DefDescriptor(0,0xFFFFF,0x9A,0x5)	; TEMPSEG: PM_InitCode
	DefDescriptor(0,0xFFFFF,0x9A,0xD)	; ALLMEMCS
	DefDescriptor(0,0xFFFFF,0x92,0xD)	; ALLMEMDS
	DefDescriptor(0,0xFFFFF,0x9A,0x1)	; RMPARTCS
	DefDescriptor(0,0xFFFFF,0x92,0x1)	; RMPARTDS
	DefDescriptor(0,0xFFFFF,0x9A,0xD)	; PMPARTCS
	DefDescriptor(0,0xFFFFF,0x92,0xD)	; PMPARTDS
;Orig_GDT_Len = $-Orig_GDT
Orig_GDT_Len = 65536
})



__udataseg__({
;;;;;;;;;;;;;;;;;;;;;;;;;;;; Uninitialized Data ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

LOADER_seg:	.word	0
RMPart_seg:	.word	0	; where the RM Part is to be put.

})



__codeseg__({
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;; API Entry/Exit Points ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

entry API_Entry_Point

API_Entry_Point:

; Called by the boot loader.
; must be far away from the top of conventional memory.
; * Entry:
;  CS,DS,ES,SS point to the API group of segments
;  the COMMAND_LINE is below APIOFS, the API offset.
;  SP is below the COMMAND_LINE. Beware, it's below 768 bytes !
;  arguments are pushed on the stack: see below

; * Never exits, but launches TUNES.

	__("Initializing the BIOS-based API.",CRLF)


;;; Init Console

; Print Init Message
	PUTS("Welcome to TUNES.",CRLF)

; Set the keyboard repeat rate to the max
	mov ax,#0x0305
	clr(bx)
	int #0x16


;;; Get parameters from the LOADER
	; Get CPU type
	pop word [CPUType]

	; Get available conventional memory
	pop dword [ConvMem]

	; Get available extended memory
	pop dword [XtdMem]

	; Get command line
	; (nothing to do; loader put it at COMMAND_LINE, zero-ended)
	zzz({
	  PUTS("Command line is:",CRLF)
	  mov si,#COMMAND_LINE
	  PUTS
	  call PrCRLF
	})


;;; Go in protected mode as soon as possible:
;;; everything is so much easier from there

; Prepare landing
	;.....

; Jump into the Protected Mode
	STEP(4)
	__("Let's jump into protected mode !",CRLF)
	br GoProtect	; original (unmoved) version
})



__pminitcode__({

;;;;; And Now, the dreaded entry point ! ;;;;;
PM_Entry_Point:
	mov eax,#RMPARTDS ; ALLMEMDS ?
	mov fs,ax
	mov ebx,#0xB8000+2*(38+5*80)
	seg fs
	mov dword [ebx+0],#0x0F4F0F4D
	call sleep_1s
	seg fs
	mov dword [ebx+4],#0x0F530F4F
	call sleep_1s
	seg fs
	mov dword [ebx+8],#0x0F200F45
	movzx esp,sp
	STOP(fs,0,0,0,'P,0x78)
	mov ecx,#16
	call sleep
	jmpi GoReal, GoRealSEG


;;; Move the RM part of the API to where it belongs: up conventional memory,
	;.....


;;; Move the PM part of the API to where it belongs: up extended memory.
	;.....


})


__rminitcode__({

RM_Return_Point:
; Restore segment registers
	clr(ax)
	mov ds,ax
   z_z({"Back in real mode:",CRLF})
	zwoz({"cs="},cs,{CRLF})
; Show that we got there
	mov bx,0xB800
	mov es,bx
	STOP(es,0,13,3,'R,0x4)	; 'R for RealMode
; Try accessing ALLMEMDS through fs.
	mov ebx,0xB8000
	STOP(fs,ebx,13,10,'A,0xC)	; 'A' for Allmem
; Reenable Interruptions
	STOP(es,0,13,4,'e,0x4)		; 'R' for RealMode
	call RM_Enable_NMI
	sti
; That's all, folks
	CGETC({CRLF,"Hit any key to reboot."})
	int  #0x19	; reboot
	;jmpi 0xFFFF,0

forget({
Test_Mode:
; This routine has been used instead of RM_Return_Point,
; to prove that returning in real mode from a 32 bit protected mode segment
; made the CPU land in such thing as a 32 bit real mode !!!
; To have it work, copy the GoReal procedure in a 32 bit segment,
; and have it jump into this routine.
; (beware: jump address should be word ofs,word 0,word seg)
; print 'M' indifferently in 32 bit and 16 bit modes
; In both modes, it will print a M white on black on the first character of
; the second line.
; In 32 bit mode, it will also print next to it a blinking {acute E}
; (which corresponds to the nop's 9090h value which is pushed then poped !!!)
	push #0xB800
	nop
	nop
	pop ds
	push #0x74D
	nop
	nop
	xor bx,bx
	push #160
	nop
	nop
	pop dx
	mov bl,dl
	mov di,bx
	pop word [bx]
	hlt		; halt, or the computer may reboot
			; before you see the result.
})

})



__pminitcode__({
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Subroutines ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
sleep_1s:
	push ecx
	mov ecx,#0x10000	; 1 M
 s1s:
	loop s1s
	pop ecx
	ret

sleep:
 sns:
	call sleep_1s
	loop sns
	ret


Setup_GDT:
	;.......

Setup_LDT:
	;......

Setup_RM_IDT:
	;......
	mov cx,#16
	push ds
	push #0
	pop ds
	mov ax,#RM_IRQ
	mov bx,#IRQ_INT_BASE
	shl bx,#2
  SRMI_0:
	mov [bx],ax
	mov [bx+2],cs
	add bx,#4
	add ax,#3
	loop SRMI_0
	pop ds
	ret

Setup_PM_IDT:
	;......

Setup_Paging:
	;......


})
