;;;;;;;;;;;;;;;;;;;;;;;;;;; Define Constants ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
APISIZE = 28*1024	; The exact value is set by external installer
			; 28K should be more than actual size, so even
			; if the value is unpatched, the boot loader will
			; still be able to boot.


;;;;;;;;;;;;;;;;;;;;;;; Define the generic header ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;Signature
;; The first 32 bytes are reserved for the signature
;; The first 20 bytes may be searched for to find the API.
;; The 12 remaining bytes may be used for version identification.

  .org APIOFS
   MagicNumber:		.long	API_MAGIC

  .org APIOFS+4
   Signature:		defb(API_NAME,0)

  .org APIOFS+28
   version_major:	.byte	MAJOR_VERSION
   version_minor:	.byte	MINOR_VERSION
   version_patchlevel:	.byte	PATCH_LEVEL
   version_internal:	.byte	INTERNAL_REVISION



;; After the signature, system fields
  .org APIOFS+32

   API_Header:
	.long	APISIZE
	.long	API_Entry_Point
	.long	APIOFS
	.long	0
	.long	0,0,0,0
